KReplace Class Reference
Main classes | Find and Replace classes

`#include <kreplace.h>`

Inheritance diagram for KReplace:

## Signals

void | replace (const QString &text, int replacementIndex, int replacedLength, int matchedLength)
Signals inherited from KFind
void | highlight (const QString &text, int matchingIndex, int matchedLength)
void | highlight (int id, int matchingIndex, int matchedLength)
void | findNext ()
void | optionsChanged ()
void | dialogClosed ()

## Public Member Functions

| KReplace (const QString &pattern, const QString &replacement, long options, QWidget *parent=0)
| KReplace (const QString &pattern, const QString &replacement, long options, QWidget *parent, QWidget *replaceDialog)
virtual | ~KReplace ()
int | numReplacements () const
virtual void | resetCounts ()
Result | replace ()
KDialogBase * | replaceNextDialog (bool create=false)
void | closeReplaceNextDialog ()
virtual bool | shouldRestart (bool forceAsking=false, bool showNumMatches=true) const
virtual void | displayFinalDialog () const
Public Member Functions inherited from KFind
| KFind (const QString &pattern, long options, QWidget *parent)
| KFind (const QString &pattern, long options, QWidget *parent, QWidget *findDialog)
virtual | ~KFind ()
bool | needData () const
void | setData (const QString &data, int startPos=-1)
void | setData (int id, const QString &data, int startPos=-1)
Result | find ()
long | options () const
virtual void | setOptions (long options)
QString | pattern () const
void | setPattern (const QString &pattern)
int | numMatches () const
virtual bool | validateMatch (const QString &text, int index, int matchedlength)
KDialogBase * | findNextDialog (bool create=false)
void | closeFindNextDialog ()
int | index () const

## Static Public Member Functions

static int | replace (QString &text, const QString &pattern, const QString &replacement, int index, long options, int *replacedLength)
static int | replace (QString &text, const QRegExp &pattern, const QString &replacement, int index, long options, int *replacedLength)
Static Public Member Functions inherited from KFind
static int | find (const QString &text, const QString &pattern, int index, long options, int *matchedlength)
static int | find (const QString &text, const QRegExp &pattern, int index, long options, int *matchedlength)

## Protected Slots

void | slotSkip ()
void | slotReplace ()
void | slotReplaceAll ()
Protected Slots inherited from KFind
void | slotFindNext ()
void | slotDialogClosed ()

## Additional Inherited Members

Public Types inherited from KFind
enum | Result { NoMatch, Match }
Protected Member Functions inherited from KFind
QWidget * | parentWidget () const
QWidget * | dialogsParent () const

## Detailed Description

A generic implementation of the "replace" function.

Author
  S.R.Haque srhaq.nosp@m.ue@i.nosp@m.ee.or.nosp@m.g, David Faure faure.nosp@m.@kde.nosp@m..org

Detail:

This class includes prompt handling etc. Also provides some static functions which can be used to create custom behavior instead of using the class directly.

Example:

To use the class to implement a complete replace feature:

In the slot connect to the replace action, after using KReplaceDialog:

// This creates a replace-on-prompt dialog if needed.
m_replace = new KReplace(pattern, replacement, options, this);
// Connect signals to code which handles highlighting
// of found text, and on-the-fly replacement.
connect( m_replace, SIGNAL( highlight( const QString &, int, int ) ),
this, SLOT( slotHighlight( const QString &, int, int ) ) );
// Connect findNext signal - called when pressing the button in the dialog
connect( m_replace, SIGNAL( findNext() ),
this, SLOT( slotReplaceNext() ) );
// Connect replace signal - called when doing a replacement
connect( m_replace, SIGNAL( replace(const QString &, int, int, int) ),
this, SLOT( slotReplace(const QString &, int, int, int) ) );

Then initialize the variables determining the "current position" (to the cursor, if the option FromCursor is set, to the beginning of the selection if the option SelectedText is set, and to the beginning of the document otherwise). Initialize the "end of search" variables as well (end of doc or end of selection). Swap begin and end if FindBackwards. Finally, call slotReplaceNext();

void slotReplaceNext()
{
KFind::Result res = KFind::NoMatch;
while ( res == KFind::NoMatch && <position not at end> ) {
if ( m_replace->needData() )
m_replace->setData( <current text fragment> );
// Let KReplace inspect the text fragment, and display a dialog if a match is found
res = m_replace->replace();
if ( res == KFind::NoMatch ) {
<Move to the next text fragment, honoring the FindBackwards setting for the direction>
}
}
if ( res == KFind::NoMatch ) // i.e. at end
<Call either m_replace->displayFinalDialog(); delete m_replace; m_replace = 0L;
or if ( m_replace->shouldRestart() ) { reinit (w/o FromCursor) and call slotReplaceNext(); }
else { m_replace->closeReplaceNextDialog(); }>
}

Don't forget delete m_find in the destructor of your class, unless you gave it a parent widget on construction.

Definition at line 97 of file kreplace.h.

## Constructor & Destructor Documentation

KReplace::KReplace | ( | const QString & | pattern,
|  | const QString & | replacement,
|  | long | options,
|  | QWidget * | parent = `0`
| ) |  |

Only use this constructor if you don't use KFindDialog, or if you use it as a modal dialog.

Parameters

  pattern | The pattern to look for.
  replacement | The replacement string.
  options | Options for the find dialog.

See also
  KFindDialog and KReplaceDialog.

Parameters

  parent | The parent widget.

Definition at line 63 of file kreplace.cpp.

KReplace::KReplace | ( | const QString & | pattern,
|  | const QString & | replacement,
|  | long | options,
|  | QWidget * | parent,
|  | QWidget * | replaceDialog
| ) |  |

This is the recommended constructor if you also use KReplaceDialog (non-modal).

You should pass the pointer to it here, so that when a message box appears it has the right parent. Don't worry about deletion, KReplace will notice if the find dialog is closed.

Parameters

  pattern | The pattern to look for.
  replacement | The replacement string.
  options | Options for the find dialog.

See also
  KFindDialog and KReplaceDialog.

Parameters

  parent | The parent widget.
  replaceDialog | A pointer to the KReplaceDialog object.

Definition at line 70 of file kreplace.cpp.

KReplace::~KReplace | ( |  | ) |

virtual

Destructor.

Definition at line 77 of file kreplace.cpp.

## Member Function Documentation

void KReplace::closeReplaceNextDialog | ( |  | ) |

Close the "replace next?" dialog.

The application should do this when the last match was hit. If the application deletes the KReplace, then "find previous" won't be possible anymore.

Definition at line 323 of file kreplace.cpp.

void KReplace::displayFinalDialog | ( |  | ) | const

virtual

Displays the final dialog telling the user how many replacements were made.

Call either this or shouldRestart().

Reimplemented from KFind.

Definition at line 102 of file kreplace.cpp.

int KReplace::numReplacements | ( |  | ) | const

inline

Return the number of replacements made (i.e.

the number of times the replace signal was emitted). Can be used in a dialog box to tell the user how many replacements were made. The final dialog does so already, unless you used setDisplayFinalDialog(false).

Returns
  The number of replacements.

Definition at line 138 of file kreplace.h.

KFind::Result KReplace::replace | ( |  | ) |

Walk the text fragment (e.g.

kwrite line, kspread cell) looking for matches. For each match, if prompt-on-replace is specified, emits the highlight() signal and displays the prompt-for-replace dialog before doing the replace.

Returns
  Whether or not there has been a match.

Definition at line 110 of file kreplace.cpp.

int KReplace::replace | ( | QString & | text,
|  | const QString & | pattern,
|  | const QString & | replacement,
|  | int | index,
|  | long | options,
|  | int * | replacedLength
| ) |  |

static

Searches the given string, replaces with the given replacement string, and returns whether a match was found.

If one is, the replacement string length is also returned.

A performance optimised version of the function is provided for use with regular expressions.

Parameters

  text | The string to search.
  pattern | The pattern to look for.
  replacement | The replacement string to insert into the text.
  index | The starting index into the string.
  options | The options to use.
  replacedLength | Output parameter, contains the length of the replaced string. Not always the same as replacement.length(), when backreferences are used.

Returns
  The index at which a match was found, or -1 if no match was found.

Definition at line 180 of file kreplace.cpp.

int KReplace::replace | ( | QString & | text,
|  | const QRegExp & | pattern,
|  | const QString & | replacement,
|  | int | index,
|  | long | options,
|  | int * | replacedLength
| ) |  |

static

Searches the given regular expression, replaces with the given replacement string, and returns whether a match was found.

If one is, the replacement string length is also returned.

Another version of the function is provided for use with strings.

Parameters

  text | The string to search.
  pattern | The regular expression pattern to look for.
  replacement | The replacement string to insert into the text.
  index | The starting index into the string.
  options | The options to use.
  replacedLength | Output parameter, contains the length of the replaced string. Not always the same as replacement.length(), when backreferences are used.

Returns
  The index at which a match was found, or -1 if no match was found.

Definition at line 196 of file kreplace.cpp.

void KReplace::replace | ( | const QString & | text,
|  | int | replacementIndex,
|  | int | replacedLength,
|  | int | matchedLength
| ) |  |

signal

Connect to this slot to implement updating of replaced text during the replace operation.

Extra care must be taken to properly implement the "no prompt-on-replace" case. For instance highlight isn't emitted in that case (some code might rely on it), and for performance reasons one should repaint after replace() ONLY if prompt-on-replace was selected.

Parameters

  text | The text, in which the replacement has already been done.
  replacementIndex | Starting index of the matched substring
  replacedLength | Length of the replacement string
  matchedLength | Length of the matched string

KDialogBase * KReplace::replaceNextDialog | ( | bool | create = `false` | ) |

Return (or create) the dialog that shows the "find next?" prompt.

Usually you don't need to call this. One case where it can be useful, is when the user selects the "Find" menu item while a find operation is under way. In that case, the program may want to call setActiveWindow() on that dialog.

Returns
  The replace next dialog.

Definition at line 82 of file kreplace.cpp.

void KReplace::resetCounts | ( |  | ) |

virtual

Call this to reset the numMatches & numReplacements counts.

Can be useful if reusing the same KReplace for different operations, or when restarting from the beginning of the document.

Reimplemented from KFind.

Definition at line 278 of file kreplace.cpp.

bool KReplace::shouldRestart | ( | bool | forceAsking = `false`,
|  | bool | showNumMatches = `true`
| ) |  | const

virtual

Returns `true` if we should restart the search from scratch.

Can ask the user, or return `false` (if we already searched/replaced the whole document without the PromptOnReplace option).

Parameters

  forceAsking | set to `true` if the user modified the document during the search. In that case it makes sense to restart the search again.
  showNumMatches | set to `true` if the dialog should show the number of matches. Set to `false` if the application provides a "find previous" action, in which case the match count will be erroneous when hitting the end, and we could even be hitting the beginning of the document (so not all matches have even been seen).

Returns
  `true`, if the search should be restarted.

Reimplemented from KFind.

Definition at line 284 of file kreplace.cpp.

The documentation for this class was generated from the following files:

- kreplace.h
- kreplace.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys